Index: /trunk/packages/vizservers/vtkvis/RpContour2D.cpp
===================================================================
--- /trunk/packages/vizservers/vtkvis/RpContour2D.cpp	(revision 2422)
+++ /trunk/packages/vizservers/vtkvis/RpContour2D.cpp	(revision 2423)
@@ -13,7 +13,9 @@
 #include <vtkCellDataToPointData.h>
 #include <vtkContourFilter.h>
+#include <vtkStripper.h>
 #include <vtkPolyDataMapper.h>
 #include <vtkUnstructuredGrid.h>
 #include <vtkProperty.h>
+#include <vtkTransform.h>
 #include <vtkDelaunay2D.h>
 #include <vtkDelaunay3D.h>
@@ -107,6 +109,28 @@
             pd->GetNumberOfStrips() == 0) {
             // DataSet is a point cloud
-            if (_dataSet->is2D()) {
+            DataSet::PrincipalPlane plane;
+            double offset;
+            if (_dataSet->is2D(&plane, &offset)) {
                 vtkSmartPointer<vtkDelaunay2D> mesher = vtkSmartPointer<vtkDelaunay2D>::New();
+                if (plane == DataSet::PLANE_ZY) {
+                    vtkSmartPointer<vtkTransform> trans = vtkSmartPointer<vtkTransform>::New();
+                    trans->RotateWXYZ(90, 0, 1, 0);
+                    if (offset != 0.0) {
+                        trans->Translate(-offset, 0, 0);
+                    }
+                    mesher->SetTransform(trans);
+                } else if (plane == DataSet::PLANE_XZ) {
+                    vtkSmartPointer<vtkTransform> trans = vtkSmartPointer<vtkTransform>::New();
+                    trans->RotateWXYZ(-90, 1, 0, 0);
+                    if (offset != 0.0) {
+                        trans->Translate(0, -offset, 0);
+                    }
+                    mesher->SetTransform(trans);
+                } else if (offset != 0.0) {
+                    // XY with Z offset
+                    vtkSmartPointer<vtkTransform> trans = vtkSmartPointer<vtkTransform>::New();
+                    trans->Translate(0, 0, -offset);
+                    mesher->SetTransform(trans);
+                }
                 mesher->SetInput(pd);
                 _contourFilter->SetInputConnection(mesher->GetOutputPort());
@@ -154,5 +178,7 @@
         _contourMapper = vtkSmartPointer<vtkPolyDataMapper>::New();
         _contourMapper->SetResolveCoincidentTopologyToPolygonOffset();
-        _contourMapper->SetInputConnection(_contourFilter->GetOutputPort());
+        vtkSmartPointer<vtkStripper> stripper = vtkSmartPointer<vtkStripper>::New();
+        stripper->SetInputConnection(_contourFilter->GetOutputPort());
+        _contourMapper->SetInputConnection(stripper->GetOutputPort());
         getActor()->SetMapper(_contourMapper);
     }
Index: /trunk/packages/vizservers/vtkvis/RpGlyphs.h
===================================================================
--- /trunk/packages/vizservers/vtkvis/RpGlyphs.h	(revision 2422)
+++ /trunk/packages/vizservers/vtkvis/RpGlyphs.h	(revision 2423)
@@ -27,6 +27,5 @@
  * \brief Oriented and scaled 3D glyph shapes
  *
- * The DataSet must be a PolyData point set
- * with vectors and/or scalars
+ * The DataSet must have vectors and/or scalars
  */
 class Glyphs : public VtkGraphicsObject {
Index: /trunk/packages/vizservers/vtkvis/RpHeightMap.cpp
===================================================================
--- /trunk/packages/vizservers/vtkvis/RpHeightMap.cpp	(revision 2422)
+++ /trunk/packages/vizservers/vtkvis/RpHeightMap.cpp	(revision 2423)
@@ -18,4 +18,5 @@
 #include <vtkImageData.h>
 #include <vtkLookupTable.h>
+#include <vtkTransform.h>
 #include <vtkDelaunay2D.h>
 #include <vtkDelaunay3D.h>
@@ -25,4 +26,5 @@
 #include <vtkDataSetSurfaceFilter.h>
 #include <vtkContourFilter.h>
+#include <vtkStripper.h>
 #include <vtkWarpScalar.h>
 #include <vtkPropAssembly.h>
@@ -35,10 +37,10 @@
 #define MESH_POINT_CLOUDS
 
-HeightMap::HeightMap(int numContours) :
+HeightMap::HeightMap(int numContours, double heightScale) :
     VtkGraphicsObject(),
     _numContours(numContours),
     _colorMap(NULL),
     _contourEdgeWidth(1.0),
-    _warpScale(1.0),
+    _warpScale(heightScale),
     _sliceAxis(Z_AXIS),
     _pipelineInitialized(false)
@@ -49,5 +51,5 @@
 }
 
-HeightMap::HeightMap(const std::vector<double>& contours) :
+HeightMap::HeightMap(const std::vector<double>& contours, double heightScale) :
     VtkGraphicsObject(),
     _numContours(contours.size()),
@@ -55,5 +57,5 @@
     _colorMap(NULL),
     _contourEdgeWidth(1.0),
-    _warpScale(1.0),
+    _warpScale(heightScale),
     _sliceAxis(Z_AXIS),
     _pipelineInitialized(false)
@@ -194,8 +196,32 @@
                 pd->GetNumberOfStrips() == 0) {
                 // DataSet is a point cloud
-                if (_dataSet->is2D()) {
+                DataSet::PrincipalPlane plane;
+                double offset;
+                if (_dataSet->is2D(&plane, &offset)) {
 #ifdef MESH_POINT_CLOUDS
                     // Result of Delaunay2D is a PolyData
                     vtkSmartPointer<vtkDelaunay2D> mesher = vtkSmartPointer<vtkDelaunay2D>::New();
+                    if (plane == DataSet::PLANE_ZY) {
+                        vtkSmartPointer<vtkTransform> trans = vtkSmartPointer<vtkTransform>::New();
+                        trans->RotateWXYZ(90, 0, 1, 0);
+                        if (offset != 0.0) {
+                            trans->Translate(-offset, 0, 0);
+                        }
+                        mesher->SetTransform(trans);
+                        _sliceAxis = X_AXIS;
+                    } else if (plane == DataSet::PLANE_XZ) {
+                        vtkSmartPointer<vtkTransform> trans = vtkSmartPointer<vtkTransform>::New();
+                        trans->RotateWXYZ(-90, 1, 0, 0);
+                        if (offset != 0.0) {
+                            trans->Translate(0, -offset, 0);
+                        }
+                        mesher->SetTransform(trans);
+                        _sliceAxis = Y_AXIS;
+                    } else if (offset != 0.0) {
+                        // XY with Z offset
+                        vtkSmartPointer<vtkTransform> trans = vtkSmartPointer<vtkTransform>::New();
+                        trans->Translate(0, 0, -offset);
+                        mesher->SetTransform(trans);
+                    }
                     mesher->SetInput(pd);
                     vtkAlgorithmOutput *warpOutput = initWarp(mesher->GetOutputPort());
@@ -205,9 +231,22 @@
                     if (_pointSplatter == NULL)
                         _pointSplatter = vtkSmartPointer<vtkGaussianSplatter>::New();
+                    if (_volumeSlicer == NULL)
+                        _volumeSlicer = vtkSmartPointer<vtkExtractVOI>::New();
                     _pointSplatter->SetInput(pd);
                     int dims[3];
                     _pointSplatter->GetSampleDimensions(dims);
                     TRACE("Sample dims: %d %d %d", dims[0], dims[1], dims[2]);
-                    dims[2] = 3;
+                    if (plane == DataSet::PLANE_ZY) {
+                        dims[0] = 3;
+                        _volumeSlicer->SetVOI(1, 1, 0, dims[1]-1, 0, dims[1]-1);
+                        _sliceAxis = X_AXIS;
+                    } else if (plane == DataSet::PLANE_XZ) {
+                        dims[1] = 3;
+                        _volumeSlicer->SetVOI(0, dims[0]-1, 1, 1, 0, dims[2]-1);
+                        _sliceAxis = Y_AXIS;
+                    } else {
+                        dims[2] = 3;
+                        _volumeSlicer->SetVOI(0, dims[0]-1, 0, dims[1]-1, 1, 1);
+                    }
                     _pointSplatter->SetSampleDimensions(dims);
                     double bounds[6];
@@ -218,8 +257,5 @@
                           bounds[2], bounds[3],
                           bounds[4], bounds[5]);
-                    if (_volumeSlicer == NULL)
-                        _volumeSlicer = vtkSmartPointer<vtkExtractVOI>::New();
                     _volumeSlicer->SetInputConnection(_pointSplatter->GetOutputPort());
-                    _volumeSlicer->SetVOI(0, dims[0]-1, 0, dims[1]-1, 1, 1);
                     _volumeSlicer->SetSampleRate(1, 1, 1);
                     vtkSmartPointer<vtkDataSetSurfaceFilter> gf = vtkSmartPointer<vtkDataSetSurfaceFilter>::New();
@@ -324,12 +360,37 @@
                 _probeFilter->SetSource(ds);
                 vtkSmartPointer<vtkImageData> imageData = vtkSmartPointer<vtkImageData>::New();
+                DataSet::PrincipalPlane plane;
+                double offset;
                 int xdim = 256;
                 int ydim = 256;
                 int zdim = 1;
+                double origin[3];
+                double spacing[3];
+                origin[0] = bounds[0];
+                origin[1] = bounds[2];
+                origin[2] = bounds[4] + (bounds[5]-bounds[4])/2.;
+                spacing[0] = (bounds[1]-bounds[0])/((double)(xdim-1));
+                spacing[1] = (bounds[3]-bounds[2])/((double)(ydim-1));
+                spacing[2] = 0;
+                if (_dataSet->is2D(&plane, &offset)) {
+                    if (plane == DataSet::PLANE_ZY) {
+                        xdim = 1;
+                        zdim = 256;
+                        origin[2] = bounds[4];
+                        spacing[0] = 0;
+                        spacing[2] = (bounds[5]-bounds[4])/((double)(zdim-1));
+                        _sliceAxis = X_AXIS;
+                    } else if (plane == DataSet::PLANE_XZ) {
+                        ydim = 1;
+                        zdim = 256;
+                        origin[2] = bounds[4];
+                        spacing[1] = 0;
+                        spacing[2] = (bounds[5]-bounds[4])/((double)(zdim-1));
+                        _sliceAxis = Y_AXIS;
+                    }
+                }
                 imageData->SetDimensions(xdim, ydim, zdim);
-                imageData->SetOrigin(bounds[0], bounds[2], bounds[4] + (bounds[5]-bounds[4])/2.);
-                imageData->SetSpacing((bounds[1]-bounds[0])/((double)(xdim-1)), 
-                                      (bounds[3]-bounds[2])/((double)(ydim-1)),
-                                      0);
+                imageData->SetOrigin(origin);
+                imageData->SetSpacing(spacing);
                 _probeFilter->SetInput(imageData);
                 gf->SetInputConnection(_probeFilter->GetOutputPort());
@@ -377,5 +438,7 @@
         _contourMapper = vtkSmartPointer<vtkPolyDataMapper>::New();
         _contourMapper->SetResolveCoincidentTopologyToPolygonOffset();
-        _contourMapper->SetInputConnection(_contourFilter->GetOutputPort());
+        vtkSmartPointer<vtkStripper> stripper = vtkSmartPointer<vtkStripper>::New();
+        stripper->SetInputConnection(_contourFilter->GetOutputPort());
+        _contourMapper->SetInputConnection(stripper->GetOutputPort());
         _contourActor->SetMapper(_contourMapper);
     }
@@ -582,16 +645,16 @@
             break;
         case Y_AXIS:
-            voi[2] = voi[3] = (int)((dims[1]-1) * ratio);
             voi[0] = 0;
             voi[1] = dims[0]-1;
+            voi[2] = voi[3] = (int)((dims[1]-1) * ratio);
             voi[4] = 0;
             voi[5] = dims[2]-1;
             break;
         case Z_AXIS:
-            voi[4] = voi[5] = (int)((dims[2]-1) * ratio);
             voi[0] = 0;
             voi[1] = dims[0]-1;
             voi[2] = 0;
             voi[3] = dims[1]-1;
+            voi[4] = voi[5] = (int)((dims[2]-1) * ratio);
             break;
         default:
@@ -666,5 +729,5 @@
  * Will override any existing contours
  */
-void HeightMap::setContours(int numContours)
+void HeightMap::setNumContours(int numContours)
 {
     _contours.clear();
@@ -724,7 +787,17 @@
 
 /**
+ * \brief Turn on/off rendering of colormaped surface
+ */
+void HeightMap::setContourSurfaceVisibility(bool state)
+{
+    if (_dsActor != NULL) {
+        _dsActor->SetVisibility((state ? 1 : 0));
+    }
+}
+
+/**
  * \brief Turn on/off rendering of contour isolines
  */
-void HeightMap::setContourVisibility(bool state)
+void HeightMap::setContourLineVisibility(bool state)
 {
     if (_contourActor != NULL) {
Index: /trunk/packages/vizservers/vtkvis/RpHeightMap.h
===================================================================
--- /trunk/packages/vizservers/vtkvis/RpHeightMap.h	(revision 2422)
+++ /trunk/packages/vizservers/vtkvis/RpHeightMap.h	(revision 2423)
@@ -42,7 +42,7 @@
     };
 
-    HeightMap(int numContours);
+    HeightMap(int numContours, double heightScale = 1.0);
 
-    HeightMap(const std::vector<double>& contours);
+    HeightMap(const std::vector<double>& contours, double heightScale = 1.0);
 
     virtual ~HeightMap();
@@ -73,7 +73,5 @@
     void setHeightScale(double scale);
 
-    void setContours(int numContours);
-
-    void setContours(int numContours, double range[2]);
+    void setNumContours(int numContours);
 
     void setContourList(const std::vector<double>& contours);
@@ -100,5 +98,7 @@
                               double vectorComponentRange[3][2]);
 
-    void setContourVisibility(bool state);
+    void setContourLineVisibility(bool state);
+
+    void setContourSurfaceVisibility(bool state);
 
     void setContourEdgeColor(float color[3]);
Index: /trunk/packages/vizservers/vtkvis/RpPolyData.cpp
===================================================================
--- /trunk/packages/vizservers/vtkvis/RpPolyData.cpp	(revision 2422)
+++ /trunk/packages/vizservers/vtkvis/RpPolyData.cpp	(revision 2423)
@@ -14,4 +14,5 @@
 #include <vtkActor.h>
 #include <vtkProperty.h>
+#include <vtkTransform.h>
 #include <vtkDelaunay2D.h>
 #include <vtkDelaunay3D.h>
@@ -78,9 +79,10 @@
     vtkPolyData *pd = vtkPolyData::SafeDownCast(ds);
     if (pd) {
-        TRACE("Verts: %d Lines: %d Polys: %d Strips: %d",
-                  pd->GetNumberOfVerts(),
-                  pd->GetNumberOfLines(),
-                  pd->GetNumberOfPolys(),
-                  pd->GetNumberOfStrips());
+        TRACE("Points: %d Verts: %d Lines: %d Polys: %d Strips: %d",
+              pd->GetNumberOfPoints(),
+              pd->GetNumberOfVerts(),
+              pd->GetNumberOfLines(),
+              pd->GetNumberOfPolys(),
+              pd->GetNumberOfStrips());
         // DataSet is a vtkPolyData
         if (pd->GetNumberOfLines() == 0 &&
@@ -88,10 +90,33 @@
             pd->GetNumberOfStrips() == 0) {
             // DataSet is a point cloud
-            if (_dataSet->is2D()) {
+            DataSet::PrincipalPlane plane;
+            double offset;
+            if (_dataSet->numDimensions() < 2 || pd->GetNumberOfPoints() < 3) {
+                // 0D or 1D or not enough points to mesh
+                _pdMapper->SetInput(pd);
+            } else if (_dataSet->is2D(&plane, &offset)) {
                 vtkSmartPointer<vtkDelaunay2D> mesher = vtkSmartPointer<vtkDelaunay2D>::New();
+                if (plane == DataSet::PLANE_ZY) {
+                    vtkSmartPointer<vtkTransform> trans = vtkSmartPointer<vtkTransform>::New();
+                    trans->RotateWXYZ(90, 0, 1, 0);
+                    if (offset != 0.0) {
+                        trans->Translate(-offset, 0, 0);
+                    }
+                    mesher->SetTransform(trans);
+                } else if (plane == DataSet::PLANE_XZ) {
+                     vtkSmartPointer<vtkTransform> trans = vtkSmartPointer<vtkTransform>::New();
+                    trans->RotateWXYZ(-90, 1, 0, 0);
+                    if (offset != 0.0) {
+                        trans->Translate(0, -offset, 0);
+                    }
+                    mesher->SetTransform(trans);
+                } else if (offset != 0.0) {
+                    // XY with Z offset
+                    vtkSmartPointer<vtkTransform> trans = vtkSmartPointer<vtkTransform>::New();
+                    trans->Translate(0, 0, -offset);
+                    mesher->SetTransform(trans);
+                }
                 mesher->SetInput(pd);
                 mesher->ReleaseDataFlagOn();
-                _pdMapper->SetInputConnection(mesher->GetOutputPort());
-#if defined(DEBUG) && defined(WANT_TRACE)
                 mesher->Update();
                 vtkPolyData *outpd = mesher->GetOutput();
@@ -101,17 +126,32 @@
                       outpd->GetNumberOfPolys(),
                       outpd->GetNumberOfStrips());
-#endif
+                if (outpd->GetNumberOfPolys() == 0) {
+                    WARN("Delaunay2D mesher failed");
+                    _pdMapper->SetInput(pd);
+                } else {
+                    _pdMapper->SetInputConnection(mesher->GetOutputPort());
+                }
             } else {
                 vtkSmartPointer<vtkDelaunay3D> mesher = vtkSmartPointer<vtkDelaunay3D>::New();
                 mesher->SetInput(pd);
                 mesher->ReleaseDataFlagOn();
-                // Delaunay3D returns an UnstructuredGrid, so feed it through a surface filter
-                // to get the grid boundary as a PolyData
-                vtkSmartPointer<vtkDataSetSurfaceFilter> gf = vtkSmartPointer<vtkDataSetSurfaceFilter>::New();
-                gf->UseStripsOn();
-                gf->SetInputConnection(mesher->GetOutputPort());
-                gf->ReleaseDataFlagOn();
-                _pdMapper->SetInputConnection(gf->GetOutputPort());
-            }
+                mesher->Update();
+                vtkUnstructuredGrid *grid = mesher->GetOutput();
+                TRACE("Delaunay3D Cells: %d",
+                      grid->GetNumberOfCells());
+                if (grid->GetNumberOfCells() == 0) {
+                    WARN("Delaunay3D mesher failed");
+                    _pdMapper->SetInput(pd);
+                } else {
+                    // Delaunay3D returns an UnstructuredGrid, so feed it 
+                    // through a surface filter to get the grid boundary 
+                    // as a PolyData
+                    vtkSmartPointer<vtkDataSetSurfaceFilter> gf = vtkSmartPointer<vtkDataSetSurfaceFilter>::New();
+                    gf->UseStripsOn();
+                    gf->SetInputConnection(mesher->GetOutputPort());
+                    gf->ReleaseDataFlagOn();
+                    _pdMapper->SetInputConnection(gf->GetOutputPort());
+                }
+             }
         } else {
             // DataSet is a vtkPolyData with lines and/or polygons
Index: /trunk/packages/vizservers/vtkvis/RpPolyData.h
===================================================================
--- /trunk/packages/vizservers/vtkvis/RpPolyData.h	(revision 2422)
+++ /trunk/packages/vizservers/vtkvis/RpPolyData.h	(revision 2423)
@@ -22,5 +22,5 @@
  * \brief VTK Mesh (Polygon data)
  *
- * The DataSet must be a PolyData object
+ * This class creates a boundary mesh of a DataSet
  */
 class PolyData : public VtkGraphicsObject {
Index: /trunk/packages/vizservers/vtkvis/RpPseudoColor.cpp
===================================================================
--- /trunk/packages/vizservers/vtkvis/RpPseudoColor.cpp	(revision 2422)
+++ /trunk/packages/vizservers/vtkvis/RpPseudoColor.cpp	(revision 2423)
@@ -15,4 +15,5 @@
 #include <vtkImageData.h>
 #include <vtkLookupTable.h>
+#include <vtkTransform.h>
 #include <vtkDelaunay2D.h>
 #include <vtkDelaunay3D.h>
@@ -84,18 +85,48 @@
             pd->GetNumberOfStrips() == 0) {
             // DataSet is a point cloud
-            if (_dataSet->is2D()) {
+            DataSet::PrincipalPlane plane;
+            double offset;
+            if (_dataSet->is2D(&plane, &offset)) {
 #ifdef MESH_POINT_CLOUDS
                 vtkSmartPointer<vtkDelaunay2D> mesher = vtkSmartPointer<vtkDelaunay2D>::New();
+                if (plane == DataSet::PLANE_ZY) {
+                    vtkSmartPointer<vtkTransform> trans = vtkSmartPointer<vtkTransform>::New();
+                    trans->RotateWXYZ(90, 0, 1, 0);
+                    if (offset != 0.0) {
+                        trans->Translate(-offset, 0, 0);
+                    }
+                    mesher->SetTransform(trans);
+                } else if (plane == DataSet::PLANE_XZ) {
+                    vtkSmartPointer<vtkTransform> trans = vtkSmartPointer<vtkTransform>::New();
+                    trans->RotateWXYZ(-90, 1, 0, 0);
+                    if (offset != 0.0) {
+                        trans->Translate(0, -offset, 0);
+                    }
+                    mesher->SetTransform(trans);
+                } else if (offset != 0.0) {
+                    // XY with Z offset
+                    vtkSmartPointer<vtkTransform> trans = vtkSmartPointer<vtkTransform>::New();
+                    trans->Translate(0, 0, -offset);
+                    mesher->SetTransform(trans);
+                }
                 mesher->SetInput(pd);
-                vtkSmartPointer<vtkDataSetSurfaceFilter> gf = vtkSmartPointer<vtkDataSetSurfaceFilter>::New();
-                gf->SetInputConnection(mesher->GetOutputPort());
-                _dsMapper->SetInputConnection(gf->GetOutputPort());
+                _dsMapper->SetInputConnection(mesher->GetOutputPort());
 #else
                 vtkSmartPointer<vtkGaussianSplatter> splatter = vtkSmartPointer<vtkGaussianSplatter>::New();
+                vtkSmartPointer<vtkExtractVOI> slicer = vtkSmartPointer<vtkExtractVOI>::New();
                 splatter->SetInput(pd);
                 int dims[3];
                 splatter->GetSampleDimensions(dims);
                 TRACE("Sample dims: %d %d %d", dims[0], dims[1], dims[2]);
-                dims[2] = 3;
+                if (plane == DataSet::PLANE_ZY) {
+                    dims[0] = 3;
+                    slicer->SetVOI(1, 1, 0, dims[1]-1, 0, dims[1]-1);
+                } else if (plane == DataSet::PLANE_XZ) {
+                    dims[1] = 3;
+                    slicer->SetVOI(0, dims[0]-1, 1, 1, 0, dims[2]-1);
+                } else {
+                    dims[2] = 3;
+                    slicer->SetVOI(0, dims[0]-1, 0, dims[1]-1, 1, 1);
+                }
                 splatter->SetSampleDimensions(dims);
                 double bounds[6];
@@ -106,7 +137,5 @@
                       bounds[2], bounds[3],
                       bounds[4], bounds[5]);
-                vtkSmartPointer<vtkExtractVOI> slicer = vtkSmartPointer<vtkExtractVOI>::New();
                 slicer->SetInputConnection(splatter->GetOutputPort());
-                slicer->SetVOI(0, dims[0]-1, 0, dims[1]-1, 1, 1);
                 slicer->SetSampleRate(1, 1, 1);
                 vtkSmartPointer<vtkDataSetSurfaceFilter> gf = vtkSmartPointer<vtkDataSetSurfaceFilter>::New();
Index: /trunk/packages/vizservers/vtkvis/RpPseudoColor.h
===================================================================
--- /trunk/packages/vizservers/vtkvis/RpPseudoColor.h	(revision 2422)
+++ /trunk/packages/vizservers/vtkvis/RpPseudoColor.h	(revision 2423)
@@ -23,6 +23,4 @@
 /**
  * \brief Color-mapped plot of data set
- * 
- * Currently the DataSet must be image data (2D uniform grid)
  */
 class PseudoColor : public VtkGraphicsObject {
Index: /trunk/packages/vizservers/vtkvis/RpVtkDataSet.cpp
===================================================================
--- /trunk/packages/vizservers/vtkvis/RpVtkDataSet.cpp	(revision 2422)
+++ /trunk/packages/vizservers/vtkvis/RpVtkDataSet.cpp	(revision 2423)
@@ -6,4 +6,5 @@
  */
 
+#include <cassert>
 #include <cstring>
 #include <cfloat>
@@ -162,4 +163,52 @@
 }
 
+void DataSet::setDefaultArrays()
+{
+    if (_dataSet->GetPointData() != NULL &&
+        _dataSet->GetPointData()->GetScalars() == NULL &&
+        _dataSet->GetPointData()->GetNumberOfArrays() > 0) {
+        for (int i = 0; i < _dataSet->GetPointData()->GetNumberOfArrays(); i++) {
+            if (_dataSet->GetPointData()->GetArray(i)->GetNumberOfComponents() == 1) {
+                TRACE("Setting point scalars to '%s'", _dataSet->GetPointData()->GetArrayName(i));
+                _dataSet->GetPointData()->SetActiveScalars(_dataSet->GetPointData()->GetArrayName(i));
+                break;
+            }
+        }
+    }
+    if (_dataSet->GetPointData() != NULL &&
+        _dataSet->GetPointData()->GetVectors() == NULL &&
+        _dataSet->GetPointData()->GetNumberOfArrays() > 0) {
+        for (int i = 0; i < _dataSet->GetPointData()->GetNumberOfArrays(); i++) {
+            if (_dataSet->GetPointData()->GetArray(i)->GetNumberOfComponents() == 3) {
+                TRACE("Setting point vectors to '%s'", _dataSet->GetPointData()->GetArrayName(i));
+                _dataSet->GetPointData()->SetActiveVectors(_dataSet->GetPointData()->GetArrayName(i));
+                break;
+            }
+        }
+    }
+    if (_dataSet->GetCellData() != NULL &&
+        _dataSet->GetCellData()->GetScalars() == NULL &&
+        _dataSet->GetCellData()->GetNumberOfArrays() > 0) {
+        for (int i = 0; i < _dataSet->GetCellData()->GetNumberOfArrays(); i++) {
+            if (_dataSet->GetCellData()->GetArray(i)->GetNumberOfComponents() == 1) {
+                TRACE("Setting cell scalars to '%s'", _dataSet->GetCellData()->GetArrayName(i));
+                _dataSet->GetCellData()->SetActiveScalars(_dataSet->GetCellData()->GetArrayName(i));
+                break;
+            }
+        }
+    }
+    if (_dataSet->GetCellData() != NULL &&
+        _dataSet->GetCellData()->GetVectors() == NULL &&
+        _dataSet->GetCellData()->GetNumberOfArrays() > 0) {
+        for (int i = 0; i < _dataSet->GetCellData()->GetNumberOfArrays(); i++) {
+            if (_dataSet->GetCellData()->GetArray(i)->GetNumberOfComponents() == 3) {
+                TRACE("Setting cell vectors to '%s'", _dataSet->GetCellData()->GetArrayName(i));
+                _dataSet->GetCellData()->SetActiveVectors(_dataSet->GetCellData()->GetArrayName(i));
+                break;
+            }
+        }
+    }
+}
+
 /**
  * \brief Read dataset using supplied reader
@@ -183,4 +232,6 @@
         ERROR("No lookup table should be specified in DataSets");
     }
+
+    setDefaultArrays();
 
 #ifdef WANT_TRACE
@@ -205,4 +256,6 @@
         ERROR("No lookup table should be specified in DataSets");
     }
+
+    setDefaultArrays();
 
 #ifdef WANT_TRACE
@@ -250,9 +303,83 @@
  * \brief Does DataSet lie in the XY plane (z = 0)
  */
-bool DataSet::is2D() const
+bool DataSet::isXY() const
 {
     double bounds[6];
     getBounds(bounds);
     return (bounds[4] == 0. && bounds[4] == bounds[5]);
+}
+
+/**
+ * \brief Returns the dimensionality of the AABB
+ */
+int DataSet::numDimensions() const
+{
+    double bounds[6];
+    getBounds(bounds);
+    int numDims = 0;
+    if (bounds[0] != bounds[1])
+        numDims++;
+    if (bounds[2] != bounds[3])
+        numDims++;
+    if (bounds[4] != bounds[5])
+        numDims++;
+
+    return numDims;
+}
+
+/**
+ * \brief Determines if DataSet lies in a principal axis plane
+ * and if so, returns the plane normal and offset from origin
+ */
+bool DataSet::is2D(DataSet::PrincipalPlane *plane, double *offset) const
+{
+    double bounds[6];
+    getBounds(bounds);
+    if (bounds[4] == bounds[5]) {
+        // Z = 0, XY plane
+        if (plane != NULL) {
+            *plane = PLANE_XY;
+        }
+        if (offset != NULL)
+            *offset = bounds[4];
+        return true;
+    } else if (bounds[0] == bounds[1]) {
+        // X = 0, ZY plane
+        if (plane != NULL) {
+            *plane = PLANE_ZY;
+        }
+        if (offset != NULL)
+            *offset = bounds[0];
+        return true;
+    } else if (bounds[2] == bounds[3]) {
+        // Y = 0, XZ plane
+        if (plane != NULL) {
+            *plane = PLANE_XZ;
+         }
+        if (offset != NULL)
+            *offset = bounds[2];
+        return true;
+    }
+    return false;
+}
+
+/**
+ * \brief Determines a principal plane with the
+ * largest two dimensions of the AABB
+ */
+DataSet::PrincipalPlane DataSet::principalPlane() const
+{
+    double bounds[6];
+    getBounds(bounds);
+    double xlen = bounds[1] - bounds[0];
+    double ylen = bounds[3] - bounds[2];
+    double zlen = bounds[5] - bounds[4];
+    if (zlen <= xlen && zlen <= ylen) {
+        return PLANE_XY;
+    } else if (xlen <= ylen && xlen <= zlen) {
+        return PLANE_ZY;
+    } else {
+        return PLANE_XZ;
+    }
 }
 
@@ -324,5 +451,13 @@
 void DataSet::getScalarRange(double minmax[2]) const
 {
-    _dataSet->GetScalarRange(minmax);
+    if (_dataSet == NULL)
+        return;
+    if (_dataSet->GetPointData() != NULL &&
+        _dataSet->GetPointData()->GetScalars() != NULL) {
+        _dataSet->GetPointData()->GetScalars()->GetRange(minmax, -1);
+    } else if (_dataSet->GetCellData() != NULL &&
+               _dataSet->GetCellData()->GetScalars() != NULL) {
+        _dataSet->GetCellData()->GetScalars()->GetRange(minmax, -1);
+    }
 }
 
@@ -419,13 +554,43 @@
  * \return the value of the nearest point or 0 if no scalar data available
  */
-double DataSet::getDataValue(double x, double y, double z) const
+bool DataSet::getScalarValue(double x, double y, double z, double *value) const
 {
     if (_dataSet == NULL)
-        return 0;
+        return false;
     if (_dataSet->GetPointData() == NULL ||
         _dataSet->GetPointData()->GetScalars() == NULL) {
-        return 0.0;
+        return false;
     }
     vtkIdType pt = _dataSet->FindPoint(x, y, z);
-    return _dataSet->GetPointData()->GetScalars()->GetComponent(pt, 0);
-}
+    if (pt < 0)
+        return false;
+    *value = _dataSet->GetPointData()->GetScalars()->GetComponent(pt, 0);
+    return true;
+}
+
+/**
+ * \brief Get nearest vector data value given world coordinates x,y,z
+ *
+ * Note: no interpolation is performed on data
+ *
+ * \param[in] x World x coordinate to probe
+ * \param[in] y World y coordinate to probe
+ * \param[in] z World z coordinate to probe
+ * \param[out] vector On success, contains the data values
+ * \return boolean indicating success or failure
+ */
+bool DataSet::getVectorValue(double x, double y, double z, double vector[3]) const
+{
+    if (_dataSet == NULL)
+        return false;
+    if (_dataSet->GetPointData() == NULL ||
+        _dataSet->GetPointData()->GetVectors() == NULL) {
+        return false;
+    }
+    vtkIdType pt = _dataSet->FindPoint(x, y, z);
+    if (pt < 0)
+        return false;
+    assert(_dataSet->GetPointData()->GetVectors()->GetNumberOfComponents() == 3);
+    _dataSet->GetPointData()->GetVectors()->GetTuple(pt, vector);
+    return true;
+}
Index: /trunk/packages/vizservers/vtkvis/RpVtkDataSet.h
===================================================================
--- /trunk/packages/vizservers/vtkvis/RpVtkDataSet.h	(revision 2422)
+++ /trunk/packages/vizservers/vtkvis/RpVtkDataSet.h	(revision 2423)
@@ -24,4 +24,9 @@
 class DataSet {
 public:
+    enum PrincipalPlane {
+        PLANE_XY,
+        PLANE_ZY,
+        PLANE_XZ
+    };
     DataSet(const std::string& name);
     virtual ~DataSet();
@@ -37,5 +42,11 @@
     vtkDataSet *copyData(vtkDataSet *ds);
 
-    bool is2D() const;
+    bool isXY() const;
+
+    int numDimensions() const;
+
+    bool is2D(PrincipalPlane *plane = NULL, double *offset = NULL) const;
+
+    PrincipalPlane principalPlane() const;
 
     const std::string& getName() const;
@@ -59,5 +70,7 @@
     void getCellSizeRange(double minmax[6], double *average) const;
 
-    double getDataValue(double x, double y, double z) const;
+    bool getScalarValue(double x, double y, double z, double *value) const;
+
+    bool getVectorValue(double x, double y, double z, double vector[3]) const;
 
     void setVisibility(bool state);
@@ -67,4 +80,6 @@
 private:
     DataSet();
+
+    void setDefaultArrays();
     void print() const;
 
